Subject: [bug#49766] [PATCH] gnu: rocksdb: set TEST_TMPDIR for faster test i/o.

From: Ryan Sundberg <[email-masked]>
Date: Wed, 28 Jul 2021 22:17:24 -0700

I give up with git send-email, here is the darn patch file. From
Thunderbird.
From 672a5b2f00a095dd1afc3259eca3f14439323e2b Mon Sep 17 00:00:00 2001
From: Ryan Sundberg <[email-masked]>
Date: Wed, 28 Jul 2021 20:43:14 -0700
Subject: [PATCH] gnu: rocksdb: set TEST_TMPDIR for faster test i/o.

The rocksdb test can take an egregious amount of time on a spinning HDD.
This will inherit guixbuild's /tmp mount for the rocksdb testing
directory.

* gnu/packages/databases.scm (rocksdb)[arguments]: set TEST_TMPDIR for
check phase
---
 gnu/packages/databases.scm | 9 +++++++++
 1 file changed, 9 insertions(+)

diff --git a/gnu/packages/databases.scm b/gnu/packages/databases.scm
index 5de79de955..da93bc758e 100644
--- a/gnu/packages/databases.scm
+++ b/gnu/packages/databases.scm
@@ -1399,6 +1399,15 @@ including field and record folding.")))
          (delete 'configure)
          ;; The default target is only needed for tests and built on demand.
          (delete 'build)
+         (add-before 'check 'mount-tmp
+           ;; Use the provided workspace directory for test files.
+           ;; Otherwise, /tmp is used which is a mount namespace on /gnu/store.
+           ;; This speeds up the build when the host /tmp is a proper tmpfs or
+           ;; other fast filesystem, as opposed to /gnu which may be a HDD.
+           (lambda _
+             (let ((test-dir (string-append (getcwd) "/../test")))
+               (mkdir test-dir)
+               (setenv "TEST_TMPDIR" (canonicalize-path test-dir)))))
          (add-before 'check 'disable-optimizations
            (lambda _
              ;; Prevent the build from passing '-march=native' to the compiler.
-- 
2.31.1